Redmine - Feature #4266

Display changeset comment on repository diff view.
2009-11-23 02:04 - Mischa The Evil

Status: Closed Start date: 2009-11-23
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 3.3.0

Resolution: Fixed

Description

To me it seems to be a useful change to include the changeset comment on the repo diff view. This way | have the comment on the
changed code and the diff itself in one view. See e.g. changeset r3084. The changeset's diff view at
http://www.redmine.org/projects/redmine/repository/revisions/3084/diff shows me the changeset ID and the actual changes as a diff.
It doesn't show me the changeset comment, which can be handy IMO.

For directory-diffs which include more changesets I'd say to display only the first comment with a full desciption. The others can
maybe displayed as links to prevent breaking the UL.

Related issues:

Related to Redmine - Feature #3988: Show diff in revision page Reopened 2009-10-07
Related to Redmine - Feature #2372: Ideas for the Revisions page New 2008-12-22
Related to Redmine - Feature #1443: Making the Repository module as nice as t... New 2008-06-13

Associated revisions

Revision 15139 - 2016-01-31 12:02 - Jean-Philippe Lang
Adds changeset comments to diff view (#4266).

Patch by Go MAEDA.

Revision 15140 - 2016-01-31 12:03 - Jean-Philippe Lang
Locals are not used in the partial (#4266).

Revision 15141 - 2016-01-31 12:07 - Jean-Philippe Lang
Display the changeset details when the diff is for a single changeset only (#4266).

Revision 15142 - 2016-01-31 12:15 - Jean-Philippe Lang
Adds links to changeset diff on the issue history (#4266).

Revision 15144 - 2016-01-31 12:37 - Jean-Philippe Lang
Tests broken (#4266).

History

#1 - 2011-03-29 13:25 - Toshi MARUYAMA
- Category changed from Ul to SCM

#2 - 2014-06-30 13:31 - Anonymous
- File _changeset.html.erb added

On my local installation | have abstracted part of app/views/repositories/revision.html.erb into a partial called _changeset.html.erb (attached). | could
then reference it in both app/views/repositories/revision.html.erb and app/views/repositories/diff.html.erb with

<%= render :partial => 'changeset', :locals => {:repository => Q@repository, :changeset => @changeset} %>

This is a small change that | recommend because it makes reviewing changes made by other developers much easier.

#3 - 2014-06-30 13:54 - Anonymous
https://www.redmine.org/projects/redmine/repository/svn/revisions/3084
http://www.redmine.org/projects/redmine/repository/revisions/3084/diff

On a related note, adding the following to app/views/issues/_changesets.html.erb is also helpful: providing a direct link from the changesets on an
issue to the diff for each changeset:

<%= link_to('(diff)"',
:controller => 'repositories',
saction => 'diff',

:id => (@issue.project,

:repository_id => changeset.repository.identifier_param,

:path = "r,

rrev => changeset.identifier) if changeset.filechanges.any? %>

| added this between the link_to_revision and <br /> tag, so you see a "(diff)" link after the "Revision xxxx" link.

#4 - 2014-06-30 17:11 - Go MAEDA

+1.

Could you create a patch file in accordance with the instructions described in Patch in order to reproduce your work?

#5 - 2014-07-01 09:37 - Anonymous
- File add_changeset_comment_to_diff_page.diff added

Here's a patch on http:/svn.redmine.org/redmine/branches/2.5-stable that adds the changeset comment to the top of the diff page, the same as the
changeset page.

#6 - 2014-07-01 09:40 - Anonymous
- File add_diff link_to_issue_changesets.diff added

...and here is a patch that adds the "(diff)" link to each changeset on the issue page to provide direct access.

#7 - 2014-07-02 05:54 - Go MAEDA
- File commit_message_displayed 3 _times.png added
Thanks for providing the patch.

| applied the patch "add_changeset_comment_to_diff_page.diff" to trunk(r13203) and got the following output. The commit message was displayed 3
times in revision page.
Revision 13196

Added by marutosijp 1 day ago
Gemfile: update builder version >= 3.0.4 (#17309)

Related issues

Revision 13196

Added by marutosijp 1 day ago
Gemfile: update builder version »>= 3.0.4 (#17309)

Related issues

Revision 13196

Added by marutosijp 1 day ago
Gemfile: update builder version »>= 3.0.4 (#17309)

Related issues

Files

View differences

i trunk
@ Gemfile (diff)

#8 - 2014-07-02 09:51 - Anonymous

NOTE: my patch was prepared on http://svn.redmine.org/redmine/branches/2.5- le NOT trunk. Also, you say that r13203 is trunk, but it isn't it is
on the 2.4-stable branch.

#9 - 2014-07-02 09:59 - Anonymous
Sorry, the link to r13203 is to the 2.4-stable branch. | guess you meant that you are up to date on trunk.

| cannot see any difference in revision.html.erb on trunk, 2.4-stable and 2.5-stable. | don't know what the problem is. It is working fine for us - we
actually have vanilla 2.5.1 deployed with this patch.

#10 - 2014-07-05 05:59 - Go MAEDA

| applied the patch "add_changeset_comment_to_diff_page.diff" to trunk(r13203) and got the following output. The commit message was
displayed 3 times in revision page.

Sorry, it is problem of my environment. | repeated several times applying the patch and 'svn revert'. While doing the work,
'app/views/repositories/_changeset.html.erb' glowed 3 times larger repeating same code 3 times.

Your patch works fine on trunk. Thanks.

#11 - 2014-07-05 07:37 - Go MAEDA
- File with_patch_applied.png added

It is useful. | hope this patch to be adopted.

with patch applied:
#12 - 2014-07-05 21:47 - Anonymous
Glad to hear it works for you Go MAEDA.

| see that you are not relating revisions to Redmine issues, but for anyone else, | recommend applying the other patch
(add_diff_link_to_issue_changesets.diff) also, which gives you a direct link to that page from the changesets on the related issues.

#13 - 2014-07-06 04:15 - Go MAEDA
- File add_diff_link_to_issue_changesets_i18n.diff added
- File add_diff_link_to_issue _changesets_i18n.png added

The patch add_diff_link_to_issue_changesets.diff is nice. It reduces some clicks. | updated the patch for i18n(replaced English word 'diff' with
label_diff).

| think you would be better to create a new issue about this because the patch seems introducing another feature.

add_diff_link_to_issue_changesets_i18n.png

#14 - 2016-01-09 08:01 - Go MAEDA
- File add_changeset_comment _to_diff page_v2.diff added

Updated Jonathan Monahan's add_changeset_comment_to_diff_page.diff to make compatible with the current trunk (r15012).

#15 - 2016-01-09 08:07 - Go MAEDA

- Target version set to 3.3.0

add_changeset_comment_to_diff page_v2.diff and add_diff_link_to_issue_changesets_i18n.diff can be applied cleanly to the current trunk.

| wish these are included in next feature release.

#16 - 2016-01-25 11:05 - Anonymous

FYI: I've just found a bug in my original patch, and it is still in the latest patch add_diff_link_to_issue_changesets_i18n.diff from Go MAEDA. The link
refers to the project of the issue, rather than the project of the changeset:

:id => @issue.project,

should be changed to

:id => changeset.repository.project,

#17 - 2016-01-31 12:19 - Jean-Philippe Lang
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Feature added. I've made a few changes so that the changeset details on the diff are displayed when the diff is for a single changeset only. Thanks.

Files

_changeset.html.erb 1.26 KB 2014-06-30 Anonymous
add_changeset_comment_to_diff_page.diff 4.25 KB 2014-07-01 Anonymous
add_diff_link_to_issue_changesets.diff 1.11 KB 2014-07-01 Anonymous
commit_message_displayed_3_times.png 67.7 KB 2014-07-02 Go MAEDA
with_patch_applied.png 71.5 KB 2014-07-05 Go MAEDA
add_diff_link_to_issue_changesets_i18n.diff 1.15 KB 2014-07-06 Go MAEDA
add_diff_link_to_issue_changesets_i18n.png 33.9 KB 2014-07-06 Go MAEDA
add_changeset_comment_to_diff page_v2.diff 4.06 KB 2016-01-09 Go MAEDA
